#TEMPLATE (CMagQuickBooksDates,'QuickBooks Style Dates'),PRIVATE,FAMILY('ABC')
#EXTENSION(QuickenDateAndTime,'This adds Quicken Style Date fields.'),DESCRIPTION('This adds Quicken Style Date fields.'),PROCEDURE
#DISPLAY('This will work for entry fields with an @D in them.')
#ATSTART
#DECLARE(%MyControls),MULTI,UNIQUE
#FOR(%CONTROL),WHERE((%ControlType = 'ENTRY' OR %ControlType = 'SPIN') AND ((INSTRING('@D',UPPER(%ControlStatement),1,1) <> 0)))
  #ADD(%MyControls,%Control)
#ENDFOR
#ENDAT
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(9001)
  #IF(%MyControls)
    ! The following alerts are for Quicken Style Date Fields
    #FOR(%MyControls)
      #FIX(%Control,%MyControls)
      %CONTROL{Prop:Alrt,255} = 443
      %CONTROL{Prop:Alrt,255} = 189
      %CONTROL{Prop:Alrt,255} = PlusKey
      %CONTROL{Prop:Alrt,255} = MinusKey
    #ENDFOR
  #ENDIF
#ENDAT
#AT(%WindowManagerMethodCodeSection,'TakeEvent','(),BYTE'),PRIORITY(6300)
  #IF(%MyControls)
  ! The following code handles 
  ! the alert keys for Quicken Style Date Fields
   CASE EVENT()
     OF EVENT:AlertKey
       CASE Field()
       #FOR(%MyControls)
         #FIX(%Control,%MyControls)
         OF %Control
           IF %ControlUse <> 0 |
             AND %Control{PROP:ReadOnly} <> TRUE
             IF KeyCode() = 443 |
              OR KeyCode() = PlusKey! Pluskey
               %ControlUse += 1
             ELSIF KeyCode() = 189 |
              OR KeyCode() = MinusKey
               %ControlUse -= 1
             END
             DISPLAY(%Control)
           END ! %ControlUse <> 0
       #ENDFOR
       END ! Case Field()
   END ! Case EVENT()
  #ENDIF
#ENDAT
#EXTENSION(QuickenDate,'This adds Quicken Style Date fields.'),DESCRIPTION('This adds Quicken Style Date fields.'),APPLICATION(QuickenDateAndTime)
#DISPLAY('This will work for entry fields ')
#DISPLAY(' with an @D in them.')
